<template>
  <with-aside>
    <template slot="aside">
      <el-menu router :default-active="$route.path" :collapse="collapse" background-color="#848c94">
        <el-menu-item index="/admin/panels">
          <router-link to="/admin/panels" class="aside-link">
            <font-awesome-icon :icon="icon('panels')" /> <span>Panels</span></router-link>
        </el-menu-item>
        <el-menu-item index="/admin/alerts">
          <router-link to="/admin/alerts" class="aside-link">
            <font-awesome-icon :icon="icon('alerts')" /> <span>Alerts</span></router-link>
        </el-menu-item>
        <el-menu-item index="/admin/labels">
          <router-link to="/admin/labels" class="aside-link">
            <font-awesome-icon :icon="icon('labels')" /> <span>Labels</span></router-link>
        </el-menu-item>
        <el-menu-item index="/admin/users">
          <router-link to="/admin/users" class="aside-link">
            <font-awesome-icon :icon="icon('users')" /> <span>Users</span></router-link>
        </el-menu-item>
        
        <el-menu-item index="#collapse" @click="toggle" class="collapse">
          <font-awesome-icon :icon="icon(collapse ? 'expand' : 'collapse')" /> <span>Collapse</span>
        </el-menu-item>
      </el-menu>
    </template>

    <slot></slot>
  </with-aside>
</template>

<script>
import FontAwesomeIcon from '@fortawesome/vue-fontawesome'
import faThLarge from '@fortawesome/fontawesome-free-solid/faThLarge'
import faBell from '@fortawesome/fontawesome-free-solid/faBell'
import faTags from '@fortawesome/fontawesome-free-solid/faTags'
import faUsers from '@fortawesome/fontawesome-free-solid/faUsers'
import faAngleDoubleLeft from '@fortawesome/fontawesome-free-solid/faAngleDoubleLeft'
import faAngleDoubleRight from '@fortawesome/fontawesome-free-solid/faAngleDoubleRight'
import WithAsideLayout from './with_aside'

export default {
  components: { 'with-aside': WithAsideLayout, FontAwesomeIcon },

  data() {
    return {
      collapse: false
    }
  },

  methods: {
    icon(name) {
      switch(name){
        case 'panels':
        return faThLarge
        case 'alerts':
        return faBell
        case 'users':
        return faUsers
        case 'labels':
        return faTags
        case 'collapse':
        return faAngleDoubleLeft
        case 'expand':
        return faAngleDoubleRight
      }
    },

    toggle() {
      this.collapse = this.collapse ? false : true
    }
  }
}
</script>
